Package: pingr
Title: Check if a Remote Computer is Up
Version: 2.0.5
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"))
  )
Description: Check if a remote computer is up. It can either just call the
    system ping command, or check a specified TCP port.
License: MIT + file LICENSE
URL: https://r-lib.github.io/pingr/, https://github.com/r-lib/pingr
BugReports: https://github.com/r-lib/pingr/issues
Depends: R (>= 3.6)
Imports: processx, utils
Suggests: covr, ps, testthat (>= 3.0.0)
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.2.3
Biarch: true
NeedsCompilation: yes
Packaged: 2024-12-12 09:19:43 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre],
  Posit Software, PBC [cph, fnd]
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Repository: CRAN
Date/Publication: 2024-12-12 10:10:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 08:18:17 UTC; unix
Archs: pingr.so.dSYM

Package: pingr
Title: Check if a Remote Computer is Up
Version: 2.0.5
Authors@R: c(
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"))
  )
Description: Check if a remote computer is up. It can either just call the
    system ping command, or check a specified TCP port.
License: MIT + file LICENSE
URL: https://r-lib.github.io/pingr/, https://github.com/r-lib/pingr
BugReports: https://github.com/r-lib/pingr/issues
Depends: R (>= 3.6)
Imports: processx, utils
Suggests: covr, ps, testthat (>= 3.0.0)
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.2.3
Biarch: true
NeedsCompilation: yes
Packaged: 2024-12-12 09:19:43 UTC; gaborcsardi
Author: Gábor Csárdi [aut, cre],
  Posit Software, PBC [cph, fnd]
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Repository: CRAN
Date/Publication: 2024-12-12 10:10:02 UTC

# pingr: check if a server is alive

[![Linux Build
Status](https://travis-ci.org/r-lib/pingr.svg?branch=master)](https://travis-ci.org/r-lib/pingr)
[![Windows Build
status](https://ci.appveyor.com/api/projects/status/github/r-lib/pingr?svg=true)](https://ci.appveyor.com/project/gaborcsardi/pingr)
[![CRAN RStudio mirror
downloads](http://cranlogs.r-pkg.org/badges/pingr)](https://r-pkg.org/pkg/pingr)

The pingr package has tools to check if a remote computer or web server
is up and some other related tools.

## ICMP ping

The `ping()` function does ICMP ping, via the system’s `ping` utility:

``` r
library(pingr)
ping("127.0.0.1")
```

    #> [1] 0.046 0.058 0.053

By default it sends three packets and measures the time it receives and
answer. It waits between sending out the packets, so if you want a
really quick check, you can just send a single packet:

``` r
ping("127.0.0.1", count = 1)
```

    #> [1] 0.067

If a machine is down (or it does not exist), then `NA` is returned
instead of the roundtrip time:

``` r
ping("192.0.2.1", count = 1)
```

    #> [1] NA

## TCP ping

With TCP ping we can check if a machine is listeing on a TCP port,
e.g. if google’s search web server is up and running:

``` r
ping_port("www.google.com", port = 80, count = 1)
```

    #> [1] 12.676

## Query the public IP address of the computer

`my_ip()` queries the public IP of the computer, either via DNS or
HTTPS:

``` r
my_ip()
```

    #> [1] "81.133.85.232"

## Check if the computer is online

`is_online()` checks if the computer is online. It makes three tries:

  - Queries myip.opendns.com on OpenDNS, see `my_ip()`.
  - Retrieves icanhazip.com via HTTPS, see `my_ip()`.
  - Retrieve Apple’s Captive Portal test page, see
    `apple_captive_test()`.

If any of these are successful, it returns `TRUE`.

``` r
is_online()
```

    #> [1] TRUE

## DNS queries

The package also contains a function to perform DNS queries. This is a
more portable and more functional version of the `utils::nsl()`
function:

``` r
nsl("www.r-project.org", type = 1L)
```

    #> $answer
    #>                 name class type ttl               data
    #> 1  www.r-project.org     1    5 900 cran.wu-wien.ac.at
    #> 2 cran.wu-wien.ac.at     1    1 300      137.208.57.37
    #> 
    #> $flags
    #>    aa    tc    rd    ra    ad    cd 
    #> FALSE FALSE  TRUE  TRUE FALSE FALSE

``` r
nsl("google.com", type = 28L)
```

    #> $answer
    #>         name class type ttl                     data
    #> 1 google.com     1   28 110 2a00:1450:4009:81a::200e
    #> 
    #> $flags
    #>    aa    tc    rd    ra    ad    cd 
    #> FALSE FALSE  TRUE  TRUE FALSE FALSE

## License

MIT © RStudio

<!-- badges: start -->
[![R-CMD-check](https://github.com/r-lib/pingr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/r-lib/pingr/actions/workflows/R-CMD-check.yaml)
[![Codecov test coverage](https://codecov.io/gh/r-lib/pingr/branch/main/graph/badge.svg)](https://app.codecov.io/gh/r-lib/pingr?branch=main)
[![CRAN RStudio mirror downloads](http://cranlogs.r-pkg.org/badges/pingr)](https://r-pkg.org/pkg/pingr)
<!-- badges: end -->

# pingr: check if a server is alive

The pingr package has tools to check if a remote computer or web server is
up and some other related tools.

## Installation

Install the package from CRAN:

```r
install.packages("pingr")
```

If you need the development version, install it from GitHub:

```r
pak::pak("r-lib/pingr")
```

## ICMP ping

The `ping()` function does ICMP ping, via the system's `ping` utility:


```r
library(pingr)
```

```
#> 
#> Attaching package: 'pingr'
```

```
#> The following object is masked from 'package:utils':
#> 
#>     nsl
```

```r
ping("127.0.0.1")
```

```
#> [1] 0.087 0.301 0.206
```

By default it sends three packets and measures the time it receives and answer.
It waits between sending out the packets, so if you want a really quick check,
you can just send a single packet:


```r
ping("127.0.0.1", count = 1)
```

```
#> [1] 0.182
```

If a machine is down (or it does not exist), then `NA` is returned instead
of the roundtrip time:


```r
ping("192.0.2.1", count = 1)
```

```
#> [1] NA
```

## TCP ping

With TCP ping we can check if a machine is listeing on a TCP port, e.g. if
google's search web server is up and running:


```r
ping_port("www.google.com", port = 80, count = 1)
```

```
#> [1] 19.228
```

## Query the public IP address of the computer

`my_ip()` queries the public IP of the computer, either via DNS or HTTPS:


```r
my_ip()
```

```
#> [1] "83.50.96.133"
```

## Check if the computer is online

`is_online()` checks if the computer is online. It makes three tries:

* Queries myip.opendns.com on OpenDNS, see `my_ip()`.
* Retrieves icanhazip.com via HTTPS, see `my_ip()`.
* Retrieve Apple's Captive Portal test page, see `apple_captive_test()`.

If any of these are successful, it returns `TRUE`.


```r
is_online()
```

```
#> [1] TRUE
```

## DNS queries

The package also contains a function to perform DNS queries. This is a
more portable and more functional version of the `utils::nsl()` function:


```r
nsl("www.r-project.org", type = 1L)
```

```
#> $answer
#>                 name class type  ttl               data
#> 1  www.r-project.org     1    5 6525 cran.wu-wien.ac.at
#> 2 cran.wu-wien.ac.at     1    1  300      137.208.57.37
#> 
#> $flags
#>    aa    tc    rd    ra    ad    cd 
#> FALSE FALSE  TRUE  TRUE FALSE FALSE
```

```r
nsl("google.com", type = 28L)
```

```
#> $answer
#>         name class type ttl                     data
#> 1 google.com     1   28 210 2a00:1450:4003:80f::200e
#> 
#> $flags
#>    aa    tc    rd    ra    ad    cd 
#> FALSE FALSE  TRUE  TRUE FALSE FALSE
```

## License

MIT © RStudio

#' Check if the local or remote computer is up
#'
#' @useDynLib pingr, .registration = TRUE
"_PACKAGE"

#' Check if a port of a server is active, measure response time
#'
#' @param destination Host name or IP address.
#' @param port Port.
#' @param continuous Logical, whether to keep pinging until
#'   the user interrupts.
#' @param verbose Whether to print progress on the screen while
#'   pinging.
#' @param count Number of pings to perform.
#' @param timeout Timeout, in seconds. How long to wait for a
#'   ping to succeed.
#' @return Vector of response times, in milliseconds.
#'   \code{NA} means no response within the timeout.
#'
#' @export
#' @examplesIf pingr:::safe_examples()
#' ping_port("r-project.org")

ping_port <- function(destination, port = 80L,
                      continuous = FALSE, verbose = continuous,
                      count = 3L, timeout = 1.0) {

  type <- "tcp"
  type <- switch(type, "tcp" = 0L, "udp" = 1L)
  timeout <- as.integer(timeout * 1000000)
  res <- .Call(r_ping, destination, port, type, continuous, verbose,
               count, timeout)
  res[ res == -1 ] <- NA_real_
  res
}

#' Ping a remote server, to see if it is alive
#'
#' This is the classic ping, using ICMP packages. Only the
#' system administrator can send ICMP packages, so we call out
#' to the system's ping utility.
#'
#' @param destination Host name or IP address.
#' @param continuous Logical, whether to keep pinging until the
#'   user interrupts.
#' @param verbose Whether to print progress on the screen while
#'   pinging.
#' @param count Number of pings to perform.
#' @param timeout Timeout for a ping response.
#' @return Vector of response times. \code{NA} means no response, in
#'   milliseconds. Currently \code{NA}s are always at the end of the vector,
#'   and not in their correct position.
#'
#' @export
#' @importFrom processx run
#' @examplesIf pingr:::safe_examples()
#' ping("8.8.8.8")
#' ping("r-project.org")

ping <- function(destination, continuous = FALSE, verbose = continuous,
                 count = 3L, timeout = 1.0) {

  if (!continuous && verbose) {
    stop("'!continuous' && 'verbose' does not work currently")
  }

  os <- ping_os(destination, continuous, count, timeout)

  status <- run(os$cmd[1], os$cmd[-1], error_on_status = FALSE, env = os$env)
  output <- strsplit(status$stdout, "\r?\n")[[1]]

  if (!continuous) {
    timings <- grep(os$regex, output, value = TRUE, perl = TRUE)
    times <- sub(os$regex, "\\1", timings, perl = TRUE)
    res <- as.numeric(times)
    length(res) <- count
    res
  } else {
    invisible()
  }
}

ping_os <- function(destination, continuous, count, timeout) {

  env <- NULL

  if (.Platform$OS.type == "windows") {
    ping_file <- file.path("C:", "windows", "system32", "ping.exe")
    if (!file.exists(ping_file)) { ping_file <- "ping" }
    cmd <- c(
      ping_file,
      "-w", int(timeout * 1000),
      if (continuous) "-t" else c("-n", count),
      destination
    )

  } else if (Sys.info()["sysname"] == "Darwin") {
    cmd <- c(
      "/sbin/ping",
      "-W", int(timeout * 1000),
      if (!continuous) c("-c", count),
      destination
    )

  } else if (Sys.info()[["sysname"]] == "Linux") {
    cmd <- c(
      "ping",
      "-W", int(timeout),
      if (!continuous) c("-c", count),
      destination
    )
    env <- c("current", LC_ALL = "C")

  } else if (Sys.info()[["sysname"]] == "SunOS") {
    if (timeout != 1.0) {
      warning("Ping `timeout` is not supported on Solaris")
    }
    cmd <- c(
      "/usr/sbin/ping",
      "-s",
      destination,
      if (!continuous) c("56", count)
    )

  } else if (.Platform$OS.type == "unix") {
    cmd <- c(
      "ping",
      "-W", int(timeout * 1000),
      if (!continuous) c("-c", count),
      destination
    )
  }

  list(cmd = cmd, env = env, regex = "^.*time=(.+)[ ]?ms.*$")
}

#' Is the computer online?
#'
#' Check if the computer is online. It does three tries:
#' * Retrieve Apple's Captive Portal test page, see [apple_captive_test()].
#' * Queries myip.opendns.com on OpenDNS, see [my_ip()].
#' * Retrieves icanhazip.com via HTTPS, see [my_ip()].
#' If any of these are successful, it returns `TRUE`.
#'
#' @param timeout Timeout for the queries. (Note: it is currently not
#'   used for the DNS query.)
#' @return Possible values: \itemize{
#'   \item \code{TRUE} Yes, online.
#'   \item \code{FALSE} No, not online.
#' }
#'
#' @export
#' @examplesIf pingr:::safe_examples()
#' is_online()

is_online <- function(timeout = 1) {
  opts <- options(timeout = timeout)
  on.exit(options(opts), add = TRUE)

  tryCatch({
    if (apple_captive_test()) return(TRUE)
  }, error = function(e) NULL)

  tryCatch({
    my_ip(method = "dns")
    return(TRUE)
  }, error = function(e) NULL)

  tryCatch({
    my_ip(method = "https")
    return(TRUE)
  }, error = function(e) NULL)

  FALSE
}

#' `is_up()` checks if a web server is up.
#'
#' @rdname ping_port
#' @param fail_on_dns_error If `TRUE` then `is_up()` fails if the DNS
#'   resolution fails. Otherwise it will return `FALSE`.
#' @param check_online Whether to check first if the computer is online.
#'   Otherwise it is possible that the computer is behind a proxy, that
#'   hijacks the HTTP connection to `destination`.
#' @export
#' @examplesIf pingr:::safe_examples()
#' is_up("google.com")
#' is_up("google.com", timeout = 0.01)

is_up <- function(destination, port = 80, timeout = 0.5,
                  fail_on_dns_error = FALSE, check_online = TRUE) {

  if (check_online && ! is_online(timeout)) return(FALSE)

  tryCatch(
    !is.na(ping_port(destination, port = port, timeout = timeout, count = 1)),
    error = function(e) {
      if (fail_on_dns_error) stop(e)
      FALSE
    })
}

context("ICMP")

test_that("We can ping localhost", {

  if (Sys.getenv("APPVEYOR") == "") {
    pr <- ping("127.0.0.1", count = 1)
    expect_true(is.double(pr))
    expect_true(length(pr) == 1)
    expect_true(pr < 1000)
  }
})

test_that("We can ping a remote host", {

  if (Sys.getenv("APPVEYOR") == "") {

    ## Non-existent IP
    pr <- ping("192.0.2.1", count = 1)
    expect_equal(pr, NA_real_)

    ## Google
    pr <- ping("google.com", count = 1)
    expect_true(is.double(pr))
    expect_true(length(pr) == 1)
    expect_true(pr < 1000)

    pr <- ping("8.8.8.8", count = 1)
    expect_true(is.double(pr))
    expect_true(length(pr) == 1)
    expect_true(pr < 1000)
  }
})

test_that("We don't wait too long", {

  ## TODO
  expect_true(TRUE)
})

context("TCP")

test_that("We can ping localhost", {

  ## Chances are, there is nothing here
  pr <- ping_port("127.0.0.1", port = 4695, count = 1)
  expect_equal(pr, NA_real_)

  ## Start web server
  r_httpd_port <- if(R.version[["svn rev"]] < 67550) {
    try(tools::startDynamicHelp(TRUE), silent = TRUE)
    getFromNamespace("httpdPort", "tools")
  } else {
    tools::startDynamicHelp(NA)
  }
  pr <- ping_port("127.0.0.1", port = r_httpd_port, count = 1)
  expect_true(is.double(pr))
  expect_true(length(pr) == 1)
  expect_true(pr < 1000)

  ## Shut down web server
  tools::startDynamicHelp(start = FALSE)
})

test_that("We can ping a remote host", {

  ## There is surely nothing here
  pr <- ping_port("igraph.org", port = 4695, count = 1)
  expect_equal(pr, NA_real_)

  ## There is surely something here
  pr <- ping_port("httpbin.org", count = 1)
  expect_true(is.double(pr))
  expect_true(length(pr) == 1)
  expect_true(pr < 1000)
})

test_that("We don't wait too long", {

  ## TODO
  expect_true(TRUE)
})

test_that("We don't wait for the resolver", {

  ## TODO
  expect_true(TRUE)
})

#' DNS query
#'
#' Perform a DNS query for a domain. It supports custom name servers,
#' and querying DNS records of certain class and type.
#'
#' @param domain Domain to query.
#' @param server Custom name server IP address, to use. Note that this
#'   must be an IP address currently. E.g. 8.8.8.8 is Google's DNS server.
#' @param type Record type to query, an integer scalar. 1L is an A record,
#'   28L is an AAAA record, etc. See e.g.
#'   https://en.wikipedia.org/wiki/List_of_DNS_record_types for the record
#'   types.
#' @param class Query class. This is usually 1L, i.e. "Internet". See e.g.
#'   https://www.iana.org/assignments/dns-parameters/dns-parameters.xhtml#dns-parameters-2
#'   for all DNS classes.
#' @return A list of two entries currently, additional entries might be
#'   added later:
#'   * `answer`: a data frame of DNS records, with columns:
#'     `name`, `class`, `type`, `ttl`, `data`. `data` is a list column and
#'     contains the IP(6) address for A and AAAA records, but it contains
#'     other data, e.g. host name for CNAME, for other records. If pingr
#'     could not parse a record (it only parses the most common records
#'     types: A, AAAA, NA, PTR, CNAME, TXT, MX, SOA), then the data of
#'     the record is included as a raw vector.
#'   * `flags`: a named logical vector of flags `aa`, `tc`, `rd`, `ra`,
#'     `ad`, `cd`. See the RFC (https://www.ietf.org/rfc/rfc1035.txt) for
#'      these. On Windows they are all set to NA currently.
#'
#' @export
#' @examplesIf pingr:::safe_examples()
#' nsl("r-project.org")
#' nsl("google.com", type = 28L)

nsl <- function(domain, server = NULL, type = 1L, class = 1L) {
  stopifnot(
    is_string(domain),
    is_string_or_null(server),
    is_type(type),
    is_class(class)
  )
  .Call(r_nsl, domain, server, class, type)
}

int <- as.integer

is_string <- function(x) {
  is.character(x) && length(x) == 1 && !is.na(x)
}

is_string_or_null <- function(x) {
  is.null(x) || is_string(x)
}

is_count <- function(x) {
  is.integer(x) && length(x) == 1 && !is.na(x)
}

is_type <- function(x) {
  is_count(x)
}

is_class <- function(x) {
  is_count(x)
}

safe_examples <- function() {
  !is_cran_check() && is_online()
}

is_cran_check <- function () {
  if (identical(Sys.getenv("NOT_CRAN"), "true")) {
    FALSE
  } else {
    Sys.getenv("_R_CHECK_PACKAGE_NAME_", "") != ""
  }
}

#' Query the computer's public IP address
#'
#' It can use a DNS query to opendns.com, if `method == "dns"`, or
#' an HTTPS query to icanhazip.com, see https://github.com/major/icanhaz.
#' The DNS query is much faster, the HTTPS query is secure.
#'
#' @param method Whether to use a DNS or HTTPS query.
#' @return Computer's public IP address as a string.
#'
#' @export
#' @examplesIf pingr:::safe_examples()
#' my_ip()
#' my_ip(method = "https")

my_ip <- function(method = c("dns", "https")) {
  method <- match.arg(method)
  if (method == "dns") my_ip_dns() else my_ip_https()
}

my_ip_dns <- function() {
  out <- nsl("myip.opendns.com", server = "208.67.222.222", type = 1L)
  if (nrow(out$answer) != 1 ||
      out$answer$type != 1L ||
      !is_ip_address(out$answer$data[[1]])) {
    stop("Cannot query my iP address via DNS")
  }

  out$answer$data[[1]]
}

is_ip_address <- function(x) {
  grepl("^[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+$", x)
}

my_ip_https <- function() {
  out <- http_get("https://ipv4.icanhazip.com/")
  out <- gsub("\\s+", "", out)

  if (!is_ip_address(out)) stop("Cannot query my IP address via https")

  out
}

http_get <- function(url) {
  tmp <- tempfile()
  on.exit(unlink(tmp, recursive = TRUE), add = TRUE)

  suppressWarnings(utils::download.file(url, tmp, quiet = TRUE))

  if (!file.exists(tmp)) stop("Cannot download `", url, "`")

  readChar(tmp, file.info(tmp)$size, useBytes = TRUE)
}

#' Download Apple's captive portal test
#'
#' If the test page, returns "Success" that means that the computer is
#' connected to the Internet.
#'
#' Note that this function will fail if the computer is offline. Use
#' [is_online()] to check if the computer is online.
#'
#' @export
#' @examplesIf pingr:::safe_examples()
#' apple_captive_test()

apple_captive_test <- function() {
  out <- http_get("http://captive.apple.com/hotspot-detect.html")
  grepl("Success", out)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/my-ip.R
\name{my_ip}
\alias{my_ip}
\title{Query the computer's public IP address}
\usage{
my_ip(method = c("dns", "https"))
}
\arguments{
\item{method}{Whether to use a DNS or HTTPS query.}
}
\value{
Computer's public IP address as a string.
}
\description{
It can use a DNS query to opendns.com, if \code{method == "dns"}, or
an HTTPS query to icanhazip.com, see https://github.com/major/icanhaz.
The DNS query is much faster, the HTTPS query is secure.
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
my_ip()
my_ip(method = "https")
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ping-package.r
\docType{package}
\name{pingr-package}
\alias{pingr}
\alias{pingr-package}
\title{Check if the local or remote computer is up}
\description{
Check if a remote computer is up. It can either
    just call the system ping command, or check a specified
    TCP port.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/r-lib/pingr#readme}
  \item Report bugs at \url{https://github.com/r-lib/pingr/issues}
}

}
\author{
\strong{Maintainer}: Gábor Csárdi \email{csardi.gabor@gmail.com}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dns.R
\name{nsl}
\alias{nsl}
\title{DNS query}
\usage{
nsl(domain, server = NULL, type = 1L, class = 1L)
}
\arguments{
\item{domain}{Domain to query.}

\item{server}{Custom name server IP address, to use. Note that this
must be an IP address currently. E.g. 8.8.8.8 is Google's DNS server.}

\item{type}{Record type to query, an integer scalar. 1L is an A record,
28L is an AAAA record, etc. See e.g.
https://en.wikipedia.org/wiki/List_of_DNS_record_types for the record
types.}

\item{class}{Query class. This is usually 1L, i.e. "Internet". See e.g.
https://www.iana.org/assignments/dns-parameters/dns-parameters.xhtml#dns-parameters-2
for all DNS classes.}
}
\value{
A list of two entries currently, additional entries might be
added later:
\itemize{
\item \code{answer}: a data frame of DNS records, with columns:
\code{name}, \code{class}, \code{type}, \code{ttl}, \code{data}. \code{data} is a list column and
contains the IP(6) address for A and AAAA records, but it contains
other data, e.g. host name for CNAME, for other records. If pingr
could not parse a record (it only parses the most common records
types: A, AAAA, NA, PTR, CNAME, TXT, MX, SOA), then the data of
the record is included as a raw vector.
\item \code{flags}: a named logical vector of flags \code{aa}, \code{tc}, \code{rd}, \code{ra},
\code{ad}, \code{cd}. See the RFC (https://www.ietf.org/rfc/rfc1035.txt) for
these. On Windows they are all set to NA currently.
}
}
\description{
Perform a DNS query for a domain. It supports custom name servers,
and querying DNS records of certain class and type.
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
nsl("r-project.org")
nsl("google.com", type = 28L)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/http.R
\name{apple_captive_test}
\alias{apple_captive_test}
\title{Download Apple's captive portal test}
\usage{
apple_captive_test()
}
\description{
If the test page, returns "Success" that means that the computer is
connected to the Internet.
}
\details{
Note that this function will fail if the computer is offline. Use
\code{\link[=is_online]{is_online()}} to check if the computer is online.
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
apple_captive_test()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ping-package.r
\name{ping}
\alias{ping}
\title{Ping a remote server, to see if it is alive}
\usage{
ping(
  destination,
  continuous = FALSE,
  verbose = continuous,
  count = 3L,
  timeout = 1
)
}
\arguments{
\item{destination}{Host name or IP address.}

\item{continuous}{Logical, whether to keep pinging until the
user interrupts.}

\item{verbose}{Whether to print progress on the screen while
pinging.}

\item{count}{Number of pings to perform.}

\item{timeout}{Timeout for a ping response.}
}
\value{
Vector of response times. \code{NA} means no response, in
milliseconds. Currently \code{NA}s are always at the end of the vector,
and not in their correct position.
}
\description{
This is the classic ping, using ICMP packages. Only the
system administrator can send ICMP packages, so we call out
to the system's ping utility.
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
ping("8.8.8.8")
ping("r-project.org")
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ping-package.r
\name{is_online}
\alias{is_online}
\title{Is the computer online?}
\usage{
is_online(timeout = 1)
}
\arguments{
\item{timeout}{Timeout for the queries. (Note: it is currently not
used for the DNS query.)}
}
\value{
Possible values: \itemize{
\item \code{TRUE} Yes, online.
\item \code{FALSE} No, not online.
}
}
\description{
Check if the computer is online. It does three tries:
\itemize{
\item Retrieve Apple's Captive Portal test page, see \code{\link[=apple_captive_test]{apple_captive_test()}}.
\item Queries myip.opendns.com on OpenDNS, see \code{\link[=my_ip]{my_ip()}}.
\item Retrieves icanhazip.com via HTTPS, see \code{\link[=my_ip]{my_ip()}}.
If any of these are successful, it returns \code{TRUE}.
}
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
is_online()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ping-package.r
\name{ping_port}
\alias{ping_port}
\alias{is_up}
\title{Check if a port of a server is active, measure response time}
\usage{
ping_port(
  destination,
  port = 80L,
  continuous = FALSE,
  verbose = continuous,
  count = 3L,
  timeout = 1
)

is_up(
  destination,
  port = 80,
  timeout = 0.5,
  fail_on_dns_error = FALSE,
  check_online = TRUE
)
}
\arguments{
\item{destination}{Host name or IP address.}

\item{port}{Port.}

\item{continuous}{Logical, whether to keep pinging until
the user interrupts.}

\item{verbose}{Whether to print progress on the screen while
pinging.}

\item{count}{Number of pings to perform.}

\item{timeout}{Timeout, in seconds. How long to wait for a
ping to succeed.}

\item{fail_on_dns_error}{If \code{TRUE} then \code{is_up()} fails if the DNS
resolution fails. Otherwise it will return \code{FALSE}.}

\item{check_online}{Whether to check first if the computer is online.
Otherwise it is possible that the computer is behind a proxy, that
hijacks the HTTP connection to \code{destination}.}
}
\value{
Vector of response times, in milliseconds.
\code{NA} means no response within the timeout.
}
\description{
Check if a port of a server is active, measure response time

\code{is_up()} checks if a web server is up.
}
\examples{
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
ping_port("r-project.org")
\dontshow{\}) # examplesIf}
\dontshow{if (pingr:::safe_examples()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
is_up("google.com")
is_up("google.com", timeout = 0.01)
\dontshow{\}) # examplesIf}
}
